				LIST P=P16F877A
	 			include "P16F877A.INC"
				include	<exsegment.h>
				include	<macro.h>

				GLOBAL	BCD_ROUTINE
			
				CODE
BCD_ROUTINE:	
				MOVF 		COUNTER,W
 				MOVWF		bin_temp
 				MOVF 		COUNTER+1,W
   				MOVWF		bin_temp+1						
 				BCF			STATUS,5
				BCF			STATUS,6
				CLRF		bcd_temp+1
				CLRF		bcd_temp

	;Count the number of thousands
tnd:	
				MOVLW		0XE8		;hex equivalent for thousand (03E8H)
				SUBWF		bin_temp
				MOVLW		0X03
				BTFSS		STATUS,0	;Subtract 3E8 from the binary number
				ADDLW		0X01
				SUBWF		bin_temp+1
				BTFSS		STATUS,C	;Check the carry
				GOTO		hnd			;Jump to check hundreds if the no. is less than thousand
				INCF		bcd_temp+1	;Otherwise increment bcd thousands area
				GOTO		tnd

	;Count the number of hundreds

hnd:
				MOVLW		0XE8		;Add the lastly subtracted "03E8" because
				ADDWF		bin_temp	;the number is less than thousand
				MOVLW		0X03
				BTFSC		STATUS,C	;Check the carry
				INCF		bin_temp+1
				ADDWF		bin_temp+1
				SWAPF		bcd_temp+1	;Swap bcd area to move thousands from hundreds area
				MOVF		bin_temp+1
				BTFSC		STATUS,2	;Check the zero flag
				GOTO		hnd2
hnd1:
				MOVLW		0X64		;Subtract hundred from the binary number
				SUBWF		bin_temp
				BTFSS		STATUS,C	;Check the carry flag
				DECFSZ		bin_temp+1	;Subtract hundred from bin temp and bin temp+1
				GOTO		hnd3
				INCF		bcd_temp+1
hnd2:
				MOVLW		0X64
				SUBWF		bin_temp	;Subtract hundred from bin temp
				BTFSS		STATUS,C
				GOTO		ten
				INCF		bcd_temp+1
				GOTO		hnd2
hnd3:	
				INCF		bcd_temp+1
				GOTO		hnd1

	;Count the number of hundreds

ten:
				MOVLW		0X64		;Add the lastly subtracted 64H because
				ADDWF		bin_temp	;the binary number is less than 64H
				BTFSC		STATUS,0
				INCF		bin_temp+1

	;Count the number of tens
	
ten1:
				MOVLW		0X0A
				SUBWF		bin_temp
				BTFSS		STATUS,0
				GOTO		one
				INCF		bcd_temp
				GOTO		ten1

	;Count the number of ones
	
one:
				MOVLW		0X0A
				ADDWF		bin_temp
				MOVF		bin_temp,w
				SWAPF		bcd_temp
				IORWF		bcd_temp
				
				CALL		DEC_CONVERT
				
				RETURN

DEC_CONVERT:
			
			;disp_area[0] = bcd_temp
				MOVF	 bcd_temp, W
				MOVWF 	 DISPAREA0
			;disp_area[1] = bcd_temp>>8
				MOVF 	 bcd_temp+1, W
				MOVWF 	 DISPAREA1
			;one_second_flag = 0;
				BCF 	BITVARIABLE,0
				RETURN
				
				END
