#include<pic.h>
#include<pic1687x.h>
#include "RS232Driver.h"
__CONFIG( XT & WDTDIS & PWRTEN & UNPROTECT );

void interrupt isr()
{
	//USART Transmitter Async Interrupt
	if(TXIE==1 && TXIF==1)
	{
		if(*USART_Async_data2transmit==0)
		{
			TXREG = 0;
			USART_Async_data2transmit = 0;
			TXIE = 0;
		}
		else
		{
			TXREG = *USART_Async_data2transmit;
			USART_Async_data2transmit++;
		}
	}
	//USART Receiver Async Interrupt
	if(RCIE==1 && RCIF==1)
	{
		if(FERR || OERR)
		{
			CREN=0;
			CREN=1;
		}
		else
		{
			fm[0] = RCREG;
			PORTB = *fm;
			USART_Async_data2transmit = fm;
			TXIE = 1;
		}
	}
}
void main()
{
	

	unsigned char buf[] = {"WELCOME TO NSK PIC PROJECT BOARD-visit us at www.nskelectronics.com"};
	TRISB = PORTB = 0;
	fm[1]=0;
	USART_Async_Init(25);
	USART_Async_Transmit(buf);
	while(1);
}
