				LIST P=P16F877A
	 			include "P16F877A.INC"
				include	<exsegment.h>
				include	<macro.h>
				
				GLOBAL	INIT_LCD,INIT_CMD_LCD,LCDPUTCMD
				GLOBAL	X_DELAY,X_DELAY1

				CODE

INIT_LCD:
				BCF		LCD_CTRL,LCD_RW
				BCF		LCD_CTRL,LCD_RS
				MOVLW	0x30				;LCD 1 LINE 5X7 MATRIX
				MOVWF	LCD_DATA
			;	SWAPF	LCD_DATA,0
			;	MOVWF	LCD_DATA1
				BSF		LCD_CTRL,LCD_E
				BCF		LCD_CTRL,LCD_E
			
				MOVLW	0x30
				MOVWF	LCD_DATA
			;	SWAPF	LCD_DATA,0
			;	MOVWF	LCD_DATA1
				BSF		LCD_CTRL,LCD_E
				BCF		LCD_CTRL,LCD_E
				
				MOVLW	0x30
				MOVWF	LCD_DATA
			;	SWAPF	LCD_DATA,0
			;	MOVWF	LCD_DATA1
				BSF		LCD_CTRL,LCD_E
				BCF		LCD_CTRL,LCD_E
				CALL	X_DELAY1
				RETURN

INIT_CMD_LCD:
				MOVLW	0x38
				CALL	LCDPUTCMD
				MOVLW	0x09
				CALL	LCDPUTCMD
				MOVLW	0x06
				CALL	LCDPUTCMD
				MOVLW	0x01
				CALL	LCDPUTCMD
				MOVLW	0x0F
				CALL	LCDPUTCMD
				RETURN

LCDPUTCMD:
   				MOVWF       LCD_TEMP            ; Command to send is in W
    			MOVLW		0x02
				CALL		X_DELAY
    			BCF         LCD_CTRL,LCD_RW    ; Set LCD in write mode
    			BCF         LCD_CTRL,LCD_RS    ; Set LCD in command mode
				MOVF        LCD_TEMP,W
    			MOVWF       LCD_DATA            ; Send data to LCD
			;	SWAPF		LCD_TEMP,W
			;	MOVWF		LCD_DATA1
    			BSF         LCD_CTRL,LCD_E     ; LCD E-line High
				NOP
				NOP
				NOP
				NOP
				NOP
    			BCF         LCD_CTRL,LCD_E     ; LCD E-line Low
    			RETURN

X_DELAY:	
			;	MOVLW		D'10'
    			MOVWF       D_VALUE             ; +1        1 cycle
X_DELAY_LOOP:
    			CALL        X_DELAY1            ; step1     wait 500uSec
    			DECFSZ      D_VALUE, F          ; step2     1 cycle
    			GOTO        X_DELAY_LOOP     ; step3     2 cycles
				RETURN     
    			
X_DELAY1:
    			MOVLW       D'249'              ; +1        1 cycle
    			MOVWF       D_VALUE1               ; +2        1 cycle1
X_DELAY1_LOOP
    			DECFSZ      D_VALUE1, F            ; step1     1 cycle
    			GOTO        X_DELAY1_LOOP       ; step2     2 cycles
				RETURN 

				END
