				LIST P=P16F877A
	 			include "P16F877A.INC"
				include	<exsegment.h>
				include	<macro.h>
			
				GLOBAL	LCDWRITE,WRITETOLCD,LCDPUTCHAR,LCDBUSY	
				EXTERN	LCDPUTCMD,X_DELAY1

				CODE
LCDWRITE:
				MOVF	DISPAREA1,0
				MOVWF	TEMP_AREA2
				CALL	WRITETOLCD
				MOVF	DISPAREA0,0
				MOVWF	TEMP_AREA2
				CALL	WRITETOLCD
				MOVLW	0x0C
				CALL	LCDPUTCMD
				MOVLW	0x02
				CALL	LCDPUTCMD
				MOVLW	0X0F
				CALL	LCDPUTCMD
				MOVLW	0x0C
				CALL	LCDPUTCMD
				CALL	X_DELAY1	
				RETURN			


WRITETOLCD:
				
				MOVF	TEMP_AREA2,0
				DECFSZ	SELECTDIGIT
				GOTO	LEVEL1
				ANDWF	MASKBIT0,0
			;	MOVWF	TEMP
			;	SWAPF	TEMP,0
				ADDWF	ASCII,0
				GOTO	LEVEL2
LEVEL1:
				ANDWF	MASKBIT1,0
				MOVWF	TEMP
				SWAPF	TEMP,0
				ADDWF	ASCII,0
				CALL	LCDPUTCHAR
				GOTO	WRITETOLCD
LEVEL2:
				CALL	LCDPUTCHAR
				MOVLW	0x02
				MOVWF	SELECTDIGIT
				RETURN


LCDPUTCHAR:
    			MOVWF       LCD_TEMP            ; Character to send is in W
    			CALL        LCDBUSY             ; Wait for LCD to be ready
				BCF         LCD_CTRL,LCD_RW    ; Set LCD in read mode
    			BSF         LCD_CTRL,LCD_RS    ; Set LCD in data mode
				MOVF        LCD_TEMP,W
    			MOVWF       LCD_DATA 			; Send data to LCD PORTD
			;	SWAPF		LCD_TEMP,W
			;	MOVWF		LCD_DATA1
    			BSF         LCD_CTRL,LCD_E     ; LCD E-line High  
				NOP
				NOP 
				BCF         LCD_CTRL,LCD_E     ; LCD E-line Low
				BCF			LCD_CTRL,LCD_RS
    			RETURN
    			
LCDBUSY:
    			BSF         STATUS,RP0          ; Select Register page 1
    			MOVLW       0xFF               ; Set PORTB for input
    			MOVWF       LCD_DATA_TRIS
			;	MOVWF		LCD_DATA_TRIS1
    			BCF         STATUS,RP0         ; Select Register page 0
				MOVLW		0x00
				MOVWF		LCD_DATA
			;	SWAPF		LCD_DATA,0
			;	MOVWF		LCD_DATA1
				
    			BCF         LCD_CTRL,LCD_RS    ; Set LCD for command mode
    			BSF         LCD_CTRL,LCD_RW    ; Setup to read busy flag
LCDBUSY1: 		MOVF        LCD_DATA,W         ; Read busy flag + DDram address
			;	SWAPF		LCD_DATA1,0
    			BSF         LCD_CTRL,LCD_E     ; LCD E-line High
				NOP
				NOP
				BCF         LCD_CTRL,LCD_E
    			ANDLW       0x80                ; Check Busy flag, High = Busy
    			BTFSC       STATUS,Z
    			GOTO        LCDBUSY1
LCDNOTBUSY:
    			BCF         LCD_CTRL, LCD_RW
				BCF			LCD_CTRL,LCD_E
    			BSF         STATUS, RP0         ; Select Register page 1
    			MOVLW       0x00
    			MOVWF       LCD_DATA_TRIS       ; Set PORTB for output
			;	MOVWF		LCD_DATA_TRIS1
    			BCF         STATUS, RP0         ; Select Register page 0
    			RETURN
		
				END
