				LIST P=P16F877A
	 			#include "P16F877A.INC"
				include	<segment.h>
				include	<declaration.h>
				include	<macro.h>
				
				EXTERN	INTRPT_ROUT, INITPROCESSOR, BCD_ROUTINE 
				EXTERN 	SERIALINIT,SERIALWRITE

RST				CODE	0x0
				PAGESEL	START
				GOTO 	START
INTRPT			CODE	0x04
				PAGESEL	INTRPT_ROUT
				GOTO	INTRPT_ROUT
				
				CODE
START:
				PAGESEL	INITPROCESSOR
				CALL	INITPROCESSOR	; initialise processor
				PAGESEL	SERIALINIT
				CALL	SERIALINIT
HERE:		
				
				BTFSC	BITVARIABLE,0	; for every one sec 
				CALL	SERIALROUTINE
				MOVLW	0X7F
				CALL	X_DELAY
				PAGESEL	HERE
				GOTO	HERE

SERIALROUTINE:

				CALL	BCD_ROUTINE
				MOVF	DISPAREA0,0
				MOVWF	TEMP_AREA2	
				PAGESEL	SERIALWRITE
				CALL	SERIALWRITE
				MOVF	DISPAREA1,0
				MOVWF	TEMP_AREA2	
				PAGESEL	SERIALWRITE
				CALL	SERIALWRITE
				MOVLW	0xFF
				CALL	X_DELAY
				RETURN

X_DELAY:	
			;	MOVLW		D'10'
    			MOVWF       D_VALUE             ; +1        1 cycle
X_DELAY_LOOP:
    			CALL        X_DELAY1            ; step1     wait 500uSec
    			DECFSZ      D_VALUE, F          ; step2     1 cycle
    			GOTO        X_DELAY_LOOP     ; step3     2 cycles
				RETURN     
    			
X_DELAY1:
    			MOVLW       D'249'              ; +1        1 cycle
    			MOVWF       D_VALUE1               ; +2        1 cycle1
X_DELAY1_LOOP
    			DECFSZ      D_VALUE1, F            ; step1     1 cycle
    			GOTO        X_DELAY1_LOOP       ; step2     2 cycles
				RETURN 	
				
				END	

				
				
				
				
				
